Attribute VB_Name = "ModFunctions"
' Mike's Raycaster v0.04
' A demonstration of raycasting in Visual Basic

' ModFunctions.bas: Supporting functions for file handling and keyboard input

' Copyright (c) 2008-2010 Michael Billington <michael.billington@gmail.com>
'
' Permission is hereby granted, free of charge, to any person obtaining a copy
' of this software and associated documentation files (the "Software"), to deal
' in the Software without restriction, including without limitation the rights
' to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
' copies of the Software, and to permit persons to whom the Software is
' furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in
' all copies or substantial portions of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
' IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
' FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
' AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
' LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
' OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
' THE SOFTWARE.

Option Explicit

Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Public Const key_pressed = &HF0000000

Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

'// Grabs the entire contents of a file
Function LoadText(FileName As String) As String
    If FileExists(FileName) Then
        Open FileName For Binary As #1
        LoadText = Space(LOF(1))
        Get #1, , LoadText
        Close #1
    End If
End Function

'// Saves text to a file
Sub SaveText(ByVal Text As String, FileName As String)
    On Error Resume Next
    Open FileName For Output As #1
    Print #1, Text
    Close #1
End Sub

'// Appends text to a file
Sub AppendText(ByVal Text As String, FileName As String)
   On Error Resume Next
   Open FileName For Append As #1
   Print #1, Text
   Close #1
End Sub

'// Function to check that a file exists
Function FileExists(ByVal strFileName As String) As Boolean
    On Error GoTo errorhandle
    If FileLen(strFileName) >= 0 Then: FileExists = True: Exit Function
errorhandle:
    FileExists = False
End Function

'// Very nifty four functions to help with string processing
Function getL(ByVal str As String, ByVal str2 As String) As String
    getL = Left(str, InStr(str, str2) - 1)
End Function

Function getR(ByVal str As String, ByVal str2 As String) As String
    getR = Right(str, Len(str) - InStr(str, str2) - Len(str2) + 1)
End Function

Function getLrev(ByVal str As String, ByVal str2 As String) As String
    getLrev = Left(str, InStrRev(str, str2) - 1)
End Function

Function getRrev(ByVal str As String, ByVal str2 As String) As String
    getRrev = Right(str, Len(str) - InStrRev(str, str2) - Len(str2) + 1)
End Function



